/*!\file
 * \brief            .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "watchdog.h"


/**
 * @brief    
 * @param pWTD:      WATCHDOG
 * @retval None
 */
void WDT_HWResetDisable(WDT_T *pWTD)
{  
    pWTD->WDOGCONTROL &= (~WDT_WDOGCONTROL_RESEN) & WDT_WDOGCONTROL_BITMASK;
}

/**
 * @brief   
 * @param pWTD:      WATCHDOG
 * @retval None
 */
void WDT_HWResetEnable(WDT_T *pWTD)
{
    pWTD->WDOGCONTROL |= WDT_WDOGCONTROL_RESEN; 
}

/**
 * @brief       
 * @param pWTD:      WATCHDOG
 * @param Value:   
 * @retval None
 */
void WDT_SetValue(WDT_T *pWTD, uint32_t value)
{  
    pWTD->WDOGLOAD = value; 
}

/**
 * @brief       
 * @param pWTD:      WATCHDOG
 * @retval   
 */
uint32_t WDT_GetValue(WDT_T *pWTD)
{  
    return pWTD->WDOGVALUE; 
}

/**
 * @brief    
 * @param pWTD:      WATCHDOG
 * @retval None
 */
void WDT_IntDisable(WDT_T *pWTD)
{  
    pWTD->WDOGCONTROL &= (~WDT_WDOGCONTROL_INTEN) & WDT_WDOGCONTROL_BITMASK; 
}

/**
 * @brief     
 * @param pWTD:      WATCHDOG
 * @retval None
 */
void WDT_IntEnable(WDT_T *pWTD)
{  
    pWTD->WDOGCONTROL |= WDT_WDOGCONTROL_INTEN;
}

/**
 * @brief             WDOGLOAD
 * @param pWTD:      WATCHDOG
 * @retval None
 */
void WDT_IntClr(WDT_T *pWTD)
{  
    pWTD->WDOGINTCLR = WDT_WDOGINTCLR_CLR; 
}
