	NAME startup

	//Stack
	SECTION CSTACK:DATA:NOROOT(3)

	//Interrupt Table
	SECTION .intvec:CODE:NOROOT(2)
        
	EXTERN __iar_program_start
	EXTERN SystemInit
        
	PUBLIC __vector_table

	DATA

__vector_table
		DCD sfe(CSTACK)
		DCD Reset_Handler       
	REPT 14
		DCD Exception
	ENDR
	//Ext Interrupts
		DCD Timer_IRQ
		DCD Watchdog_IRQ
		DCD UART_1_IRQ
		DCD UART_2_IRQ
		DCD UART_3_IRQ
		DCD UART_4_IRQ
		DCD SPI_1_IRQ
		DCD SPI_2_IRQ
		DCD GPIO_A_IRQ
		DCD GPIO_B_IRQ
                
		DCD GPIO_C_IRQ
		DCD GPIO_D_IRQ
		DCD GPIO_E_IRQ
		DCD GPIO_F_IRQ
		DCD GPIO_G_IRQ
		DCD GPIO_H_IRQ
		DCD Spacewire1_IRQ
		DCD Spacewire2_IRQ      // DCD QEP_IRQ

	
                DCD CAN1_IRQ      //	DCD TMTX_IRQ  
		DCD CAN2_IRQ      //	DCD TMCD_IRQ
                
		DCD Manchester1_IRQ     //  DCD PWM1_IRQ  
		DCD Manchester2_IRQ     //  DCD PWM2_IRQ 
		DCD Manchester3_IRQ     //  DCD PWM3_IRQ 
		DCD Manchester4_IRQ     //  DCD PWM4_IRQ 
	REPT 2
		DCD Unknown_INTR
	ENDR
		DCD DMA_DONE_SPI_1_IRQ
		DCD DMA_DONE_SPI_2_IRQ
		DCD DMA_DONE_UART_1_IRQ
		DCD DMA_DONE_UART_2_IRQ
                
		DCD DMA_DONE_UART_3_IRQ
		DCD DMA_DONE_UART_4_IRQ	

	THUMB
        
        PUBWEAK Reset_Handler
        SECTION .text:CODE:REORDER(2)
        
Reset_Handler
        LDR R0,=SystemInit
        BLX R0
        LDR R0,=__iar_program_start
        BX R0

        PUBWEAK Exception                               //0
        PUBWEAK Timer_IRQ                               //1
        PUBWEAK Watchdog_IRQ                            //2
        PUBWEAK UART_2_IRQ                              //3
        PUBWEAK UART_1_IRQ
        PUBWEAK UART_3_IRQ
        PUBWEAK UART_4_IRQ
        PUBWEAK SPI_1_IRQ
        PUBWEAK SPI_2_IRQ
        PUBWEAK GPIO_A_IRQ
        
        PUBWEAK GPIO_B_IRQ
        PUBWEAK GPIO_C_IRQ
        PUBWEAK GPIO_E_IRQ 
        PUBWEAK GPIO_D_IRQ
        PUBWEAK GPIO_F_IRQ
        PUBWEAK GPIO_G_IRQ
        PUBWEAK GPIO_H_IRQ
        PUBWEAK Spacewire1_IRQ
        PUBWEAK Spacewire2_IRQ             //  PUBWEAK QEP_IRQ 
     
        
  
        PUBWEAK CAN1_IRQ                   //   PUBWEAK TMTX_IRQ
        
        PUBWEAK CAN2_IRQ                   //   PUBWEAK TMCD_IRQ
        PUBWEAK Manchester1_IRQ         //  PUBWEAK PWM1_IRQ 
        PUBWEAK Manchester2_IRQ         //  PUBWEAK PWM2_IRQ 
        PUBWEAK Manchester3_IRQ         //  PUBWEAK PWM3_IRQ 
        PUBWEAK Manchester4_IRQ         //  PUBWEAK PWM4_IRQ 
        PUBWEAK DMA_DONE_SPI_1_IRQ
        PUBWEAK DMA_DONE_SPI_2_IRQ
        PUBWEAK DMA_DONE_UART_1_IRQ
        PUBWEAK DMA_DONE_UART_2_IRQ
        PUBWEAK DMA_DONE_UART_3_IRQ
        
        PUBWEAK DMA_DONE_UART_4_IRQ        
        SECTION .text:CODE:REORDER(1)
Exception
		B Exception

Unknown_INTR
		B Unknown_INTR

Timer_IRQ  
Watchdog_IRQ  
UART_1_IRQ  
UART_2_IRQ  
UART_3_IRQ  
UART_4_IRQ  
SPI_1_IRQ  
SPI_2_IRQ  
GPIO_A_IRQ  
GPIO_B_IRQ  
GPIO_C_IRQ  
GPIO_D_IRQ  
GPIO_E_IRQ  
GPIO_F_IRQ  
GPIO_G_IRQ  
GPIO_H_IRQ  
Spacewire1_IRQ  
Spacewire2_IRQ  // QEP_IRQ  
CAN1_IRQ  //TMTX_IRQ 
CAN2_IRQ  //TMCD_IRQ  
 

Manchester1_IRQ  // PWM1_IRQ 
Manchester2_IRQ  // PWM2_IRQ 
Manchester3_IRQ  // PWM3_IRQ 
Manchester4_IRQ  // PWM4_IRQ 
DMA_DONE_SPI_1_IRQ  
DMA_DONE_SPI_2_IRQ  
DMA_DONE_UART_1_IRQ  
DMA_DONE_UART_2_IRQ  
DMA_DONE_UART_3_IRQ  
DMA_DONE_UART_4_IRQ  
	END
