/*!\file
 * \brief         FPU.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "fpu_test.h"


char dbg_buffer[256];                                                           //   
const uint32_t sys_freq = 80000000;                                             //  

/**
 * @brief   FPU
 *   
 * @retval true/false -   /.
 */
bool FPU_Test()
{
    FPU_Init();                                                                 //   FPU.
    float result [24];                                                          //   
    PRINT(" FPU");
    
    PRINT(" : 0");                   
    result[0] = FPU_SUB(155.625, 1.5);                                          //       FPU
    if (result[0] != 154.125) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }
        
    PRINT(" : 1");
    
    result[1] = FPU_SUB(1.5, 1.5);                                              //       FPU
    if (result[1] != 0) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }
        
    PRINT(" : 2");
    
    result[2] = FPU_ADD(1.5, 155.625);                                          //        FPU
    if (result[2] != 157.125) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }

    PRINT(" : 3");
    result[3] = FPU_ADD(155.625, 1.5);                                          //        FPU
    if (result[3] != 157.125) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }   
    
    PRINT(" : 4");
    result[4] = FPU_ADD(155.625, -1.5);                                         //        FPU
    if (result[4] != 154.125)
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }

    PRINT(" : 5");
    result[5] = FPU_ADD(-155.625, 1.5);                                         //        FPU
    if (result[5] != -154.125) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
        //return false;
    }    
    
    PRINT(" : 6");
    result[6] = FPU_MUL(155.625, 1.5);                                          //       FPU
    if (result[6] != 233.4375) 
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
        //return false;
    }
        
    PRINT(" : 7");        
    result[7] = FPU_MUL(1.5, 155.625);                                          //       FPU
    if (result[7] != 233.4375) 
    { 
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
     //   return false;
    }        
        
    PRINT(" : 8");
    result[8] = FPU_MUL(155.625, -1.5);                                         //       FPU    
    if (result[8] != -233.4375) 
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
      //  return false;
    }        

    PRINT(" : 9");        
    result[9] = FPU_MUL(-155.625, 1.5);                                         //       FPU 
    if (result[9] != -233.4375) 
    {
        PRINT("      :   "); 
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
       // return false;
    }

    PRINT(" : 10 - ");
    result[10] = FPU_SIN(0.5);                                                    //     FPU
    if (result[10] != (float)4.79425549E-1)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
      //  return false;
    }

    PRINT(" : 11 - ");
    result[11] = FPU_COS(0.5);                                                    //     FPU
    if (result[11] != (float)8.7758255E-1)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
      //  return false;
    }

    PRINT(" : 12 -  ");
    result[12] = FPU_sqrt(100);                                                 //      FPU
    if (result[12] != (float)10)
    {
        PRINT("      :    ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
      //  return false;
    }


    PRINT(" : 13 -   ");
    result[13] = FPU_pow2(10);                                                  //     FPU
    if (result[13] != (float)100)
    {
        PRINT("      :     ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
     //   return false;
    }


    PRINT(" : 14 -   ");
    result[14] = FPU_pow3(10);                                                  //     FPU
    if (result[14] != (float)1000)
    {
        PRINT("      :     ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART

     //   return false;
    }


    PRINT(" : 15 - ");
    result[15] = FPU_tg(0.5);                                                   //     FPU
    if (result[15] != (float)5.4630249733E-1)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
     //   return false;
    }

    PRINT(" : 16 - ");
    result[16] = FPU_atg(0.5);                                                  //     FPU
    if (result[16] != (float)4.63647604E-1)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
     //   return false;
    }

    PRINT(" : 17 - ");
    result[17] = FPU_ASIN(0.5);                                                  //     FPU
    if (result[17] != (float)5.2359879011E-1)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
      //  return false;
    }

    PRINT(" : 18 - ");
    result[18] = FPU_ACOS(0.5);                                                  //     FPU
    if (result[18] != (float)1.04719758)
    {
        PRINT("      :   ");
        FPU_DeInit();                                                           //   FPU.
        DBG_TX_Flush();                                                         //   ,    ,   UART
        return false;
    }


    PRINT(" FPU  "); 
    FPU_DeInit();                                                               //   FPU.
    DBG_TX_Flush();                                                             //   ,    ,   UART
    return true;  
}

