/*!\file
 * \brief         GPIO.
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

/*
 *    GPIO   X12     GPIO,
 *      OLED-.   
 *      OLED- .
 */

#include "gpio_test.h"


char dbg_buffer[256];                                                           //   
const uint32_t sys_freq = 80000000;                                             //  

/**
 * @brief   GPIO
 * @param gpio:    c  GPIO
 *   
 * @retval None.
 */
static unsigned int GPIO_subtest(GPIO_T * gpio)
{
    unsigned int result = 0;     
    gpio->OUTENSET = (1<<1);    ///< H[1] 
   
    gpio->DATAOUT = 0x2;                                                          //                                    
    if (gpio->DATA&0xF != 0x6)
    {
        PRINT("\t\t\t\tERROR: OUTENABLESET reg write 0x0000FFFF fail. Value = 0x%08x\n", gpio->OUTENSET);
        result++;
    }

    return result;
}

/**
 * @brief   GPIO
 *   
 * @retval errors -  .
 */
unsigned int GPIO_test()
{
    
    PRINT("\n********** GPIO test start **********\n");   
     
    unsigned int errors = 0;
       
    PRINT("\t\t\tGPIO_A test...\n");
    errors += GPIO_subtest(GPIO_H);                                             //  GPIO_A
              
    PRINT("\tGPIO test complete. Errors count = %d\n", errors);
      
    return errors;
}

