/**
  ******************************************************************************
  * @file    SSD1306.h
  * @author  Waveshare Team
  * @version V1.0
  * @date    19-January-2017
  * @brief   This file contains all the functions prototypes for the OLED firmware driver.

  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, WAVESHARE SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2017 Waveshare</center></h2>
  ******************************************************************************
  */


#ifndef _SSD1306_H_
#define _SSD1306_H_

#include "SSD1306_Cfg.h"

#define OLED_CMD    0
#define OLED_DAT    1

typedef enum {
  LeftMode = 0,
  RightMode,
  OffMode,
  OnMode
}SCROL_MODE;

extern uint8_t OLED_GRAM[128][8];

extern void SPI2_Init(void);

extern void OLED_SetHorizontalScroll(SCROL_MODE Mode);
extern void OLED_SetDisplayEnable(bool TurnOn);
extern void OLED_ClearDisplay(void);
extern void Delay_us(uint32_t Time);
extern void OLED_Refresh_Gram(void);
void OLED_SetDisplay(void)  ;
extern void OLED_DrawPoint(uint8_t X, uint8_t Y, uint8_t Fill);
extern void OLED_Fill(uint8_t x1,uint8_t y1,uint8_t x2,uint8_t y2,uint8_t dot);
extern void OLED_ShowChar(uint8_t X, uint8_t Y, uint8_t Chr, uint8_t Size, uint8_t Mode);
extern void OLED_ShowString(uint8_t X, uint8_t Y, const uint8_t *Str);
extern void OLED_Init(void);



#endif

/******************* (C) COPYRIGHT 2014 Waveshare *****END OF FILE*******************/

