/*!\file
 * \brief           - M29W800DT45N.
 *
 * Copyright(C)   , 2015
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */
    
#include "chip_5023BC016.h"
#include "system.h"
#include "flash.h"

/*         */
uint8_t FLASH_CheckStatus(void)
{
    uint16_t DQ6T0, DQ6T1, DQ5;
    do {
      DQ6T0 = *((uint16_t*)(0x0000FB00));
      DQ6T1 = *((uint16_t*)(0x0000FB00));
//      DQ5 = *((uint16_t*)(0x00000FB00));
    } while ((DQ6T0 != DQ6T1));// && (!DQ5)); 
    return 0;//DQ5;
}
uint8_t FLASH_CheckStatus_t(uint32_t timeout)
{
    uint16_t DQ6T0, DQ6T1, DQ5;
    do {
      DQ6T0 = *((uint16_t*)(0x0000FB00));
      DQ6T1 = *((uint16_t*)(0x0000FB00));
//      DQ5 = *((uint16_t*)(0x00000FB00));
      timeout--;
    } while ((DQ6T0 != DQ6T1)&&(timeout!=0));// && (!DQ5)); 
    return 0;//DQ5;
}
/*    -    */
void FLASH_ReadResetMode(void)
{
    FLASH_PROG_REG0    = 0xAAAA;
    FLASH_PROG_REG1    = 0x5555;
    FLASH_PROG_REG_ANY = 0xF0F0; 
}

/*    -   AutoSelect */
void FLASH_AutoSelectMode(uint32_t* ManufacturerCode, uint32_t* DeviceCode)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0x9090; 
    if (ManufacturerCode != _NULL) {
      *ManufacturerCode = *(uint16_t *)(0x00000008);}
    if (DeviceCode != _NULL) {
      *DeviceCode = *(uint16_t *)(0x0000000A);}    
}

/*   16-   -. */
uint8_t FLASH_Program(uint32_t Address, uint16_t Data)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0xA0A0; 
    *(volatile uint16_t *)(Address) = Data;
    return FLASH_CheckStatus_t(1000000000);    
}  

/*    -   Bypass. */
void FLASH_UnlockBypass(void)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0x2020; 
}

/*    16-   -   Bypass.*/
uint8_t FLASH_BypassProgram(uint32_t Address, uint16_t Data)
{  
    FLASH_PROG_REG_ANY = 0xA0A0;
    *(volatile uint16_t *)(Address) = Data;
//    return FLASH_CheckStatus();    
        return FLASH_CheckStatus_t(1000000);    

 } 

/*    -   Bypass. */
void FLASH_BypassReset(void)
{
    FLASH_PROG_REG_ANY = 0x9090;
    FLASH_PROG_REG_ANY = 0x0000; 
}

/*   -.    0xFFFF */
uint8_t FLASH_ChipErase(void)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0x8080;
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0x1010;    
    return FLASH_CheckStatus();    
} 

/*    -.    0xFFFF */
uint8_t FLASH_BlockErase(uint32_t BlockAddress)
{
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    FLASH_PROG_REG0 = 0x8080;
    FLASH_PROG_REG0 = 0xAAAA;
    FLASH_PROG_REG1 = 0x5555;
    *(volatile uint16_t *)(BlockAddress) = 0x3030;
    return FLASH_CheckStatus();    
} 

/*     - */
void FLASH_EraseSuspend(void)
{
    FLASH_PROG_REG_ANY = 0xB0B0;
}

/*     - */
void FLASH_EraseResume(void)
{
    FLASH_PROG_REG_ANY = 0x3030; 
}

/*    -   CFI */
void FLASH_CFIMode(void)
{
    *(volatile uint16_t *)(0x000000AA) = 0x9898; 
}
 
/*           */
void FLASH_Write(uint32_t base_addr, uint8_t *data_ptr, uint16_t data_count)
{
  for(uint16_t i = 0; i < data_count; i+=2) {
     FLASH_Program((base_addr+i), *((uint16_t *)(data_ptr+i)));
         for(int l =0;l<1000;l++);
  }
}

/*             Bypass*/
void FLASH_BypassWrite(uint32_t base_addr, uint8_t *data_ptr, uint16_t data_count)
{
  FLASH_UnlockBypass();
  for(uint16_t i = 0; i < data_count; i+=2) {
     FLASH_BypassProgram((base_addr+i), *((uint16_t *)(data_ptr+i)));
    for(int l =0;l<1000;l++); 
  }
  FLASH_BypassReset();
  
}