/*!\file
 * \brief    ,          - M29W800DT45N.
 *
 * Copyright(C)   , 2015
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#ifndef FLASH_H_
#define FLASH_H_

#include "types.h"   

/*            "" */
#define FLASH_PROG_REG0 (*(volatile uint16_t*)(0x00000AAA))                     /**<     (0555    )*/ 
#define FLASH_PROG_REG1 (*(volatile uint16_t*)(0x00000554))                     /**<     (02AA    ) */ 
#define FLASH_PROG_REG_ANY (*(volatile uint16_t*)(0x00000666))                     /**<     (02AA    ) */ 
/**
 * @brief	   -   
 */
void FLASH_SetReadMode(void);   


/**
 * @brief	  -.    0xFFFF
 */
void FLASH_EraseChip(void);        

/**
 * @brief                
 * @param       base_addr     :   - c     
 * @param       data_ptr      :     
 * @param       data_count    :    .    
 */
void FLASH_Write16Bits(uint16_t addr, uint16_t data);

/**
 * @brief	      ()
 * @param	firmware_data :     
 * @param	byte_size     :    .    
 */
void FLASH_Write(uint32_t base_addr, uint8_t *data_ptr, uint16_t data_count);

/**
 * @brief	      ()
 * @param	firmware_data :     
 * @param	byte_size     :    .    
 */
void FLASH_WriteFirmware(uint8_t *firmware_data, uint16_t byte_size);

void FLASH_AutoSelectMode(uint32_t* ManufacturerCode, uint32_t* DeviceCode);
void FLASH_ReadResetMode(void);
uint8_t FLASH_ChipErase(void);
#endif