/*!\file
 * \brief            GPIO.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "gpio_test.h"

/**
 * \brief  GPIO
 *
 *    GPIO
 *
 *      :
 *                    -   gpio H1  H2
 *                    -   gpio H1   gpio H2
 *                    -   gpio H1   
 *                    -  gpio H1  
 *                    -    gpio H2          
 *                    -     gpio H2  -    .  -   
 *       
 *      ,    .
 *          Workspace: 
 *                      - periph_gpio_ram -    
 *                      - periph_gpio_ext -     
 */   
int main()
{
    SystemInit();                                                               //  
    clockInit();                                                                //   
    DBG_UART_Init();                                                            //  UART  
    gpioInit();                                                                 //  GPIO
    
    GPIO_test();                                                                //  GPIO
    
    while(1) 
    {
        DBG_TX_Process();                                                       //  ,    ,   UART
    }
}