/*!\file
 * \brief    ,       .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#ifndef _TEST_MEMORY_H_
#define _TEST_MEMORY_H_

#include "types.h"



/**
 * @brief     
 */
typedef enum 
{
    TEST_GALOPPING,                                                             /**<  ""*/
    TEST_COUNTER,                                                               /**<  ""*/
    TEST_MARCHAL,                                                               /**<  ""*/
    TEST_CHESS                                                                  /**<  ""*/
}TEST_TYPE;

/**
 * @brief   
 */
typedef enum 
{
    RADIX_32 = 4,                                                               /**< 4 */
    RADIX_16 = 2,                                                               /**< 2 */
    RADIX_8 = 1                                                                 /**< 1 */
}TEST_RADIX;

/**
 * @brief       
 */
typedef struct _TEST_BLOCK_ 
{
    uint32_t Addr;                                                              /**<    (   4!!!)*/
    uint32_t Size;                                                              /**<    (   4!!!)*/
}TEST_BLOCK, *PTEST_BLOCK;

/**
 * @brief      
 */
typedef struct _TEST_CFG_ 
{
    TEST_TYPE type;                                                             /**<  : "", "", ""  ""*/
    TEST_RADIX radix;                                                           /**<    */
}TEST_CFG, *PTEST_CFG;

/**
 * @brief      
 */
typedef struct _TEST_ERRORS_ 
{
    uint32_t EDAC_Errors;                                                       /**<  EDAC*/
    uint32_t Correct_Errors;                                                    /**<  */
    uint32_t Errors;                                                            /**<   */
}TEST_ERRORS, *PTEST_ERRORS;

/**
 * @brief      
 */
typedef struct _TEST_MEM_ 
{
    TEST_BLOCK block;                                                           /**<      */
    TEST_CFG param;                                                             /**<      */
    TEST_ERRORS errors;                                                         /**<     */
}TEST_MEM, *PTEST_MEM;  

/**
 * @brief      
 */
void MEMTest_Write(uint32_t Addr, TEST_RADIX Radix, uint32_t Word);

/**
 * @brief      
 */
uint32_t MEMTest_Read(uint32_t Addr, TEST_RADIX Radix);

/**
 * @brief      
 */
void MEMTest_ZeroBlock(uint32_t Addr, uint32_t Size);

/**
 * @brief    ""
 */
bool MEMTEST_Counter(PTEST_MEM pMEMTest);

/**
 * @brief   ""
 */
bool MEMTEST_Gallop(PTEST_MEM pMEMTest);

/**
 * @brief    " "
 */
bool MEMTEST_Marsch(PTEST_MEM pMEMTest);

/**
 * @brief   
 * @param Addr : 
 * @return   
 */
bool MEMTEST_generic(PTEST_MEM pMEMTest);



#endif

