/*!\file
 * \brief       OLED ,   SSP.
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */


#include "chip_5023BC016.h"
#include "system.h"
#include "debug_uart.h"
#include <string.h>
#include "spi.h"
#include "SSD1306_Cfg.h"
#include "SSD1306.h"

extern const uint8_t _111Bitmaps[]; 
const uint32_t sys_freq = 50000000;                                             //    
static SPI_CONFIG_T ssp_format;                                                 //  SPI
const uint8_t Str[] = {"CPU_5023BC016 "};                                       // ,   
uint16_t Position = 0;

/**
 * @brief   
 */
void GetString(uint8_t *str)
{  
    uint16_t pos = 0;
    
    for(pos=0; pos<16; pos++)
    {
    
        if(Position == strlen((char *)Str)-1)
        {
            Position = 0;
        }
        else 
        {
            Position +=1;
        } 
        str[pos] = Str[Position];  
    }
}

/**
 * @brief  GPIO    SPI
 */
void Gpio_SPI_Init()
{
    GPIO_D->ALTFUNCSET = (1 << 14);                                             //SPI2_MOSI
    GPIO_D->ALTFUNCSET = (1 << 12);                                             //SPI2_SCK
    GPIO_D->ALTFUNCSET = (1 << 9);                                              //SPI1_MISO
    GPIO_D->ALTFUNCSET = (1 << 13);                                             //SPI2_MISO
    GPIO_D->ALTFUNCSET = (1 << 10);                                             //SPI1_MISO
    GPIO_D->ALTFUNCSET = (1 << 8);                                              //SPI1_SCK
    GPIO_D->ALTFUNCSET = (1 << 11);                                             //SPI2_SS
    GPIO_D->ALTFUNCSET = (1 << 7);                                              //SPI1_SS
}


/**
 * \brief  OLED
 *
 *     SPI-Oled
 *      OLED     SPI1.	
 *      ()  oled 
 *     -    ,  - 
 *      ,    .
 *          Workspace: 
 *                      - periph_ssp_oled_ram -    
 *                      - periph_ssp_oled_ext -       
 */
 int main(void)
{

    SystemInit();                                                               //  
  
    SPI_Init(SPI1);                                                             //  SPI
  
    ssp_format.frameFormat = SPI_FRF_SPI;                                       //  SPI  Motorola
    ssp_format.bits = SPI_BITS_9;                                               //    9 
    ssp_format.clockMode = SPI_CLOCK_MODE0;                                                             
  
    SPI_SetFormat(SPI1, ssp_format.bits,                                        //    
                  ssp_format.frameFormat,
                  ssp_format.clockMode);
    SPI_Enable(SPI1);                                                           //   
    
    Gpio_SPI_Init();                                                            //  GPIO    SPI

    OLED_Init();                                                                //  OLED 
  
    uint16_t Y;
    uint16_t X;
  
    uint32_t OffSetY = 1;
  
    uint32_t C = 128*OffSetY;
 
    uint8_t Mess[16] = {" CPU 5023BC016 "};
  
    for( Y = 0; Y < 50 - OffSetY - 1; Y++ )
    {
        for( X = 0; X < 128; X++ )
        {
            OLED_DrawPoint(X, Y, _111Bitmaps[C++]);
        }
    }
    
      OLED_ShowString(0, 50, Mess);
  
    OLED_SetDisplayEnable(false);
  
    OLED_Refresh_Gram();

    OLED_SetHorizontalScroll(LeftMode);
    
    OLED_SetDisplayEnable(true);
    
 /* do{
    
    Delay_us(1000000);
    
  } while(true);
    
     */ while(1){
  }

}

