
/*!\file
 * \brief         .
 *
 * Copyright(C)   , 2017
 * Copyright(C)     
 *   .
 *
 *  ,    ,    
 *  ,       
 *  " ".     " " 
 *  - , " "    , 
 *   ,      , 
 *         . 
 *  " "       
 *  ,       ,  , 
 *      ,  - . 
 *  " "         
 *   .  " "     
 *   ,        
 *     .
 *
 *   , ,      
 *       " "  
 *       ,  , 
 *         
 * " ".         .
 */

#include "timer_test.h"


const uint32_t sys_freq = 80000000;                                             //  
char dbg_buffer[256];                                                           //   
uint32_t count = 0;                                                             // 

/**
 * @brief   Timer_IRQ
 */
void Timer_IRQ(void)
{
    PRINT("   : %d", count++);
    if(count==10)
    {      
        //    
        TIMER_Disable(TIMER1);                                                  //  
        NVIC_DisableIRQ(0);                                                     //  
        PRINT(" TIMER  ");
    }
    DBG_TX_Flush();                                                             //   ,    ,   UART
    TIMER_IntClr(TIMER1);                                                       //     
}


/**
 * @brief  
 */
uint8_t TIMER_Test(void)
{
    PRINT(" TIMER1");
    DBG_TX_Flush();                                                             //   ,    ,   UART
    TIMER_SetValue(TIMER1,50000000);                                            //   
  
    //    
    TIMER_IntEnable(TIMER1);                                                    //    
    NVIC_EnableIRQ(Timer1,0);                                                   //  
    
    //  
    TIMER_Enable(TIMER1);                                                       //  
    while (count < 10) {}
    DBG_TX_Flush();                                                             //   ,    ,   UART
    return true;
}


